#include <stdio.h>
#include <string.h>
#define NOME 40
#define EMAIL 40
#define TELEFONE 15
#define MORADA 60
#define SizeH sizeof(Header)
#define SizeR sizeof(Header)

typedef struct header {
	long primeiro;
	long livre;
} Header;

typedef struct registo {
	char nome [NOME];
	char email [EMAIL];
	char telefone [TELEFONE];
	char morada [MORADA];
	long proximo;
} Registo;

FILE *criaLista (char fich []) {
	Header h;
	FILE *f;
	
	if (f = fopen (fich,"w+")) {
		h.primeiro = 0l;
		h.livre = 0l;
		fwrite (&h, 1, SizeH, f);
	}
	return f;
}

FILE *abreLista (char fich []) {
	FILE *f;
	
	if (f = fopen (fich, "r+")) return f;
	else return (criaLista (fich));
}

long falloc (FILE *f) {
	Header h;
	Registo r;
	long res;
	
	fseek (f, 0l, SEEK_SET);
	fread (&h, 1, SizeH, f);
	if (res = h.livre) {
		fseek (f, res, SEEK_SET);
		fread (&r, 1, SizeR, f); 
		h.livre = r.proximo;
		fseek (f, 0l, SEEK_SET);
		fwrite (&h, 1, SizeH, f);
	} else {
		fseek (f, 0l, SEEK_END);
		res = ftell (f);
	}
	return res;
}

void ffree (FILE *f, long p) {
	Header h;
	Registo r;
	
	fseek (f, 0l, SEEK_SET);
	fread (&h, 1, SizeH, f);
	r.proximo = h.livre;
	h.livre = p;
	fseek (f, 0l, SEEK_SET);
	fwrite (&h, 1, SizeH, f);
	fseek (f, p, SEEK_SET);
	fwrite (&r, 1, SizeR, f);
}

long acrescenta (FILE *f, long p,
                 char nom[], char em[], char tel[], char mor[]) {
	Registo r; Header h;
	long novo, ant=0l, res=p;
	int continua = 1;
	
	while ((p != 0l) && continua) {
		fseek (f, p, SEEK_SET);
		fread (&r, 1, SizeR, f);
		if (strcmp (nom, r.nome) > 0) {
			ant = p; p = r.proximo;
		} else continua=0;
	}
	
	strcpy (r.nome, nom);
	strcpy (r.email, em);
	strcpy (r.telefone, tel);
	strcpy (r.morada, mor);
	r.proximo = p;
	
	novo = falloc (f);
	fseek (f, novo, SEEK_SET);
	fwrite(&r, 1, SizeR, f);
	
	if (ant == 0l) {
		fseek (f, 0l, SEEK_SET);
		fread (&h, 1, SizeH, f);
		h.primeiro = novo;
		fseek (f, 0l, SEEK_SET);
		fwrite (&h, 1, SizeH, f);
		res = novo;
	} else {
		fseek (f, ant, SEEK_SET);
		fread (&r, 1, SizeR, f);
		r.proximo = novo;
		fseek (f, ant, SEEK_SET);
		fwrite (&r, 1, SizeR, f);
	}
	return res;
}

long remove_da_lista (FILE *f, long p, char nom[]) {
	long res=p, ant=0l, prox;
	int continua = 1, comp = 1;
	Registo r; Header h;
	
	while (continua && (p != 0l)){
		fseek (f, p, SEEK_SET);
		fread (&r, 1, SizeR, f);
		if ((comp = (strcmp(r.nome, nom))) >= 0) continua = 0;
		else { 
			ant = p; p = r.proximo;
		}
	}
	if (comp == 0) {
		prox = r.proximo;
		ffree (f, p);
		if (ant == 0l) {
			fseek (f, 0L, SEEK_SET);
			fread (&h, 1, SizeH, f);
			h.primeiro = res = prox;
			fseek (f, 0L, SEEK_SET);
			fwrite (&h, 1, SizeH, f);
		} else {
			fseek (f, ant, SEEK_SET); 
			fread (&r, 1, SizeR, f);
			r.proximo = prox;
			fseek (f, ant, SEEK_SET); 
			fwrite (&r, 1, SizeR, f);
		}
	}
	return res;
}

void printLista (FILE *f) {
	Registo r;
	Header h;
	long posicao;
	
	fseek (f, 0l, SEEK_SET);
	fread (&h, 1, SizeH, f);
	posicao = h.primeiro;
	
	while (posicao != 0l) {
		fseek (f, posicao, SEEK_SET);
		fread (&r, 1, SizeR, f);
		printf("Nome: %s\nEmail: %s\nTelefone: %s\nMorada: %s\n%s\n",
		       r.nome, r.email, r.telefone, r.morada, 
		       "------------------------------------");
		posicao = r.proximo;
	} 
}

int main(int argc, char *argv[]){
	FILE *f;
	long principio;
	
	if (argc != 2) {
		printf ("Usage: %s filename\n", argv[0]);
		return 1;
	} else if ((f = abreLista (argv[1])) == NULL) {
		printf ("%s: cannot access %s\n", argv[0], argv[1]);
		return 2;
	} else {
		principio = 0l;
		principio = acrescenta (f, principio, "Joo",     "joao@pi", "12345678", "rua de cima,1");
		principio = acrescenta (f, principio, "Joel",     "joel@pi", "23456789", "rua de cima,2");
		principio = acrescenta (f, principio, "Manuel",   "manu@pi", "34567890", "rua de cima,3");
		principio = acrescenta (f, principio, "Zacarias", "zaca@pi", "45678901", "rua de cima,4");
		principio = acrescenta (f, principio, "Bruno",    "brun@pi", "56789012", "rua de cima,5");
		principio = acrescenta (f, principio, "Abel",     "abel@pi", "67890123", "rua de cima,6");
		principio = acrescenta (f, principio, "Filipe",   "fili@pi", "78901234", "rua de cima,7");
		printLista(f);
		principio = remove_da_lista (f, principio, "Joo");
		principio = acrescenta (f, principio, "Joaquim",  "joaq@pi", "89012345", "rua de cima,8");
		printLista(f);
		return 0;
	}

}
